Subject: Re: [PATCH 3/3] AFS: Implement basic file write support

From: Andrew Morton <[email-masked]>
Date: Wed, 9 May 2007 03:41:35 -0700

On Wed, 09 May 2007 11:25:47 +0100 David Howells <[email-masked]> wrote:

> > > +	set_page_dirty(page);
> > > +
> > > +	if (PageDirty(page))
> > > +		_debug("dirtied");
> > > +
> > > +	return 0;
> > > +}
> > 
> > One would normally run mark_inode_dirty() after any i_size_write()?
> 
> Not in this case, I assume, because set_page_dirty() ultimately calls
> __mark_inode_dirty(), but I could be wrong.

set_page_dirty() will set I_DIRTY_PAGES only.  ie: the inode has dirty
pagecache data.

To tell the VFS that the inode itself is dirty one needs to run
mark_inode_dirty().  Or maybe mark_inode_dirty_sync() but I can never for
the life of me remember what that thing does.